// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawnlibs.hpp"
#include "util/mathutils.hpp"
#include "display/Texture.hpp"

#define NEW_TRUETYPE_CHAR_BEGIN 0x00
#define NEW_TRUETYPE_CHAR_END 0xFF

namespace Dawn {
  struct TrueTypeCharacterInfo {
    glm::vec2 advance;
    glm::vec2 bitmapSize;
    glm::vec2 bitmapPosition;
    float_t textureY;
  };

  void _newTrueTypePlaceholder(
    FT_Face face,
    Texture &texture,
    std::map<FT_ULong, struct TrueTypeCharacterInfo> &charStore
  );
}