// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/shader/Shader.hpp"
#include "display/shader/buffers/RenderPipelineShaderBuffer.hpp"

#define UI_SHADER_PROGRAM_PRIORITY 100

namespace Dawn {
  struct UICanvasShaderParameterBufferData {
    glm::mat4 projection;
    glm::mat4 view;
  };

  class UICanvasShaderParameterBuffer :
    public ShaderParameterBuffer<struct UICanvasShaderParameterBufferData>
  {
  };
  
  class UIShader : public Shader {
    public:
      shaderparameter_t paramModel;
      shaderparameter_t paramColor;
      shaderparameter_t paramTexture;
      shaderparameter_t paramHasTexture;
      shaderbufferlocation_t bufferUiCanvas;

      void compile() override;
  };
}