// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "util/XmlParser.hpp"

namespace Dawn {
  struct VNSceneItem {
    std::string ref;
    std::string prefab;
    std::string className;
  };

  class VNSceneItemParser : public XmlParser<struct VNSceneItem> {
    protected:
      std::vector<std::string> getRequiredAttributes() override;
      std::map<std::string, std::string> getOptionalAttributes() override;
      int32_t onParse(
        Xml *node,
        std::map<std::string, std::string> values,
        struct VNSceneItem *out,
        std::string *error
      ) override;
  };
}